#pragma once
#include "ScriptletDialog.h"
#include "ScriptletContainerFactory.h"
//#include "../UpdaterDocument.h"
//#include "../Command/InstallUpdateCommand.h"
#include "ValueConverter.h"
#include "Application.h"
#include "NButton.h"
#include "MessageBox.h"
#include "TipCommand.h"
#include "UpgraderModel.h"


namespace tipupgrader
{
	class AgreementDlg : public CScriptletDialog
	{
	public:
		DECLARE_COMPONENT_CREATOR(AgreementDlg);
		AgreementDlg(void):CScriptletDialog(IDD_CUSTOMBASEDIALOG) {}
		virtual ~AgreementDlg(void) {}
		static UINT_PTR Call(/*TipServiceData* data, */AgreementUrlList& urlList, BOOL& bEnableCoreValue, HWND hWndParent = ::GetActiveWindow() );

		//override
		void OnCreateContent(LPARAM lParam);
	};

	class AgreementDialogOkAction
	{
	public:
		DECLARE_PROPERTY_CONTAINER(AgreementDialogOkAction)
		AgreementDialogOkAction(void) {}
		~AgreementDialogOkAction(void) {}

		BOOL GetPushed( CComponent* pActionComponent, LPCTSTR name )
		{
			CRootContainer *pRootContainer = pActionComponent->GetRootContainer();
			CComponent *pBtn = pRootContainer->FindName(name);
			if( NULL == pBtn )
				return FALSE;

			CNButton *pButton = dynamic_cast<CNButton *>(pBtn);
			return pButton->GetPushed();
		}

		void Execute(CComponent* pActionComponent)
		{
			HWND hWndOwner = pActionComponent->GetOwnerWindow();
			::EndDialog(hWndOwner, IDOK);

			BOOL bAgreeAgreement = GetPushed(pActionComponent, _T("agree_agreement_checkbutton"));
			BOOL bSetCoreValue = GetPushed(pActionComponent, _T("set_corevalue_checkbutton"));
/*			
			SetAgreementDlgValueCommand* command = dynamic_cast<SetAgreementDlgValueCommand*>(TipCommandFactory::get_instance()->CreateAction(_T("SetAgreementDlgValueCommand")));
			if (command)
			{
				command->SetAgreeAgreement(bAgreeAgreement);
				command->SetCoreValue(bSetCoreValue);
				command->Execute();
			}
*/
		}

	};

	class AgreementDialogCancelAction
	{
	public:
		DECLARE_PROPERTY_CONTAINER(AgreementDialogCancelAction)
		AgreementDialogCancelAction(void) {}
		~AgreementDialogCancelAction(void) {}
		void Execute(CComponent* pActionComponent)
		{

			UINT retVal = MessageBox::Call(Application::LoadString(_T("IDS_MSG_CANCELCHANGEDAGREEMENT"))
										, Application::LoadString(_T("IDS_AGREEMENTCHANGE")), MB_YESNO);

			if (retVal == IDYES)
			{
				HWND hWndOwner = pActionComponent->GetOwnerWindow();
				::EndDialog(hWndOwner, IDCANCEL);
			}
		}
	};
	class DialogSystemCloseAction
	{
	public:
		DECLARE_PROPERTY_CONTAINER(DialogCancelAction)
		DialogSystemCloseAction(void) {}
		~DialogSystemCloseAction(void) {}
		void Execute(CComponent* pActionComponent)
		{

			UINT retVal = MessageBox::Call(Application::LoadString(_T("IDS_MSG_CANCELCHANGEDAGREEMENT"))
				, Application::LoadString(_T("IDS_AGREEMENTCHANGE")), MB_YESNO);

			if (retVal == IDYES)
			{
				HWND hWndOwner = pActionComponent->GetOwnerWindow();
				::EndDialog(hWndOwner, IDCANCEL);
			}
		}
	};

	class ViewFullAgreementCommand :  public TipCommand
	{
	public:
		DECLARE_PROPERTY_TIPACTION(ViewFullAgreementCommand)
		ViewFullAgreementCommand(void):m_index(0) {}
		virtual ~ViewFullAgreementCommand(void) {}

		void SetIndex(int index) { m_index = index; }

		//override
		BOOL ExecuteImpl();
	private:
		int m_index;
	};


	class ViewFullAgreement1Action
	{
	public:
		DECLARE_PROPERTY_CONTAINER(ViewFullAgreement1Action)
		ViewFullAgreement1Action(void) {}
		~ViewFullAgreement1Action(void) {}

		void Execute(CComponent* pActionComponent)
		{
			ViewFullAgreementCommand* command = dynamic_cast<ViewFullAgreementCommand*>(TipCommandFactory::get_instance()->CreateAction(_T("ViewFullAgreementCommand")));
			if (command)
			{
				command->SetIndex(0);
				command->Execute();
			}
		}
	};

	class ViewFullAgreement2Action
	{
	public:
		DECLARE_PROPERTY_CONTAINER(ViewFullAgreement2Action)
		ViewFullAgreement2Action(void) {}
		~ViewFullAgreement2Action(void) {}

		void Execute(CComponent* pActionComponent)
		{
			ViewFullAgreementCommand* command = dynamic_cast<ViewFullAgreementCommand*>(TipCommandFactory::get_instance()->CreateAction(_T("ViewFullAgreementCommand")));
			if (command)
			{
				command->SetIndex(1);
				command->Execute();
			}
		}
	};
	
	class CheckAgreementAction
	{
	public:
		DECLARE_PROPERTY_CONTAINER(CheckAgreementAction)
		CheckAgreementAction(void) {}
		~CheckAgreementAction(void) {}

		void Execute(CComponent* pActionComponent)
		{
			CNButton *pCheck = dynamic_cast<CNButton *>(pActionComponent);
			CComponent* pConfirmBtn = pActionComponent->GetRootContainer()->FindName(_T("confirm_button"));
			if (pConfirmBtn)
			{
				pConfirmBtn->EnableWindow(pCheck->GetPushed());
				pConfirmBtn->Invalidate();
			}
		}
	};

};
